// This Source Code Form is subject to the terms of the Mozilla Public
// License, v. 2.0. If a copy of the MPL was not distributed with this
// file, You can obtain one at https://mozilla.org/MPL/2.0/.

nz-card
  #ryax-header
    div
      h2 API Keys
      span
        ng-container(*ngIf="apiKeyEnabled$ | async as enabled; else disabled")
        ng-template(#disabled)
          #ryax-disable Disabled, your API is Public
        ng-template(#enabled)
          #ryax-enable Enabled, your API is private

      p Grant API access if any of these keys is found in the 'X-API-KEY' header. It is recommended to create one key per client.
    div
      nz-switch([ngModel]="apiKeyEnabled$ | async", [nzLoading]="loading$ | async", (click)="toggleApiKeyEnabled()")


  h3 Available Keys
  ng-container(*ngIf="apiKeyList$ | async as apiKeys")
    nz-spin([nzSpinning]="loading$ | async")
      nz-table([nzData]="apiKeys", nzSize="middle", [nzOuterBordered]="true", [nzShowPagination]="false")
        thead
          tr
            th Name
            th Creation
            th Last Use
            th Expiration
            th Status
            th Actions
        tbody
          tr(*ngFor="let apiKey of apiKeys" )
            td {{ apiKey.name }}
            td {{ apiKey.creationDate.toLocaleString() }}
            td {{ apiKey.lastUseDate.toLocaleString() }}
            td {{ apiKey.expirationDate.toLocaleString() }}
            td
              span.important {{ apiKey.status }}
            td
              ng-container(*ngIf="apiKey.status === 'Valid'" )
                button(nz-button, nzSize="small", nzDanger, (click)="revokeApiKey(apiKey.id)")
                  span Revoke
              ng-container(*ngIf="!(apiKey.status === 'Valid')" )
                button(nz-button, nzSize="small", (click)="deleteApiKey(apiKey.id)")
                  span Delete

  ng-container(*ngIf="(newApiKey$ | async) != null")
    nz-modal([nzVisible]="(newApiKey$ | async) != null", nzFooter=null, [nzWidth]="800", nzClosable=false, nzCloseIcon="" )
      ng-container(*nzModalTitle)
        h2 New API Key Created
        p Secret key to access your API
      ng-container(*nzModalContent)
        p.warning
          span WARNING:
          | This Key will only be displayed once ! Be sure to keep it in a safe place.
        nz-input-group(nzSearch, nzSize="large", [nzAddOnAfter]="suffixButton")
          input(type="text", nz-input, readonly=true, [value]="(newApiKey$ | async)!.apiKey")
        ng-template(#suffixButton)
          button(nz-button, nzGhost, nzSize="large", [cdkCopyToClipboard]="(newApiKey$ | async)!.apiKey", (cdkCopyToClipboardCopied)="copied($event)") Copy to clipboard
      ng-container(*nzModalFooter)
        button(nz-button, nzType="primary", (click)="closeNewApiKeyModal()") OK, I have saved my API key

  h3 Add a Key
  form(nz-form, [nzLayout]="'horizontal'", [formGroup]="validateForm", (ngSubmit)="addApiKey()")
    nz-form-item
      nz-form-label(nzRequired) New API Key name
      nz-form-control(nzHasFeedback, nzErrorTip="API Key name should not be empty")
        input(nz-input, type="name", formControlName="name")
    nz-form-item
      nz-form-label Expiration (Defaults to 1 year of not set)
      nz-form-control
        nz-date-picker(formControlName="expirationDate", [nzDisabledDate]="notInThePast")
    button(nz-button, nzType="primary", [disabled]="!validateForm.valid") Add API Key
